package com.community.huiju.factory.impl;

import com.community.huiju.factory.PlatformVendors;
import com.community.huiju.vendor.constants.dao.IDoorMachineOperation;
import com.community.huiju.vendor.constants.dao.IEntranceGuardOperation;
import com.community.huiju.vendor.constants.dao.IFaceOperation;
import com.community.huiju.vendor.constants.dao.IPersonOperation;
import com.community.huiju.vendor.constants.info.PlatformVendorsInfo;
import com.community.huiju.vendor.impl.hk.*;
import lombok.Data;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Component;

@Data
public class HKPlatformVendors extends PlatformVendors {

    private IPersonOperation iPersonOperation;

    private IFaceOperation iFaceOperation;

    private IEntranceGuardOperation iEntranceGuardOperation;

    private IDoorMachineOperation iDoorMachineOperation;

    @Override
    public Object createPlatformVendor(PlatformVendorsInfo platformVendorsInfo) {
        iPersonOperation = new HKPersonOperationImpl(platformVendorsInfo);
        iFaceOperation = new HKFaceOperationImpl(platformVendorsInfo);
        iEntranceGuardOperation = new HKEntranceGuardOperationImpl(platformVendorsInfo);
        iDoorMachineOperation = new HKDoorMachineOperationImpl(platformVendorsInfo);
        return new HKCombination(iPersonOperation, iFaceOperation, iEntranceGuardOperation, iDoorMachineOperation);
    }
}
