package com.community.huiju.model;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.io.Serializable;
import java.time.LocalDateTime;
import java.util.List;

/**
 * <p>
 * 小区商铺表
 * </p>
 *
 * @author jobob
 * @since 2019-05-10
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
public class TpShop implements Serializable {

    private static final long serialVersionUID = 1L;
    
    @TableId(value = "id", type = IdType.AUTO)
    private Integer id;
    
    /**
     * 小区ID
     */
    private Integer communityId;

    /**
     * 商铺名称
     */
    private String shopName;

    /**
     * 商铺说明
     */
    private String remark;

    /**
     * 排序(权重)
     */
    private String sort;

    /**
     * 商铺类型
     */
    private Integer shopTypeId;

    /**
     * 商铺状态 1是已上架 2是已下架
     */
    private String shopStatus;

    /**
     * 商铺电话
     */
    private String shopTel;

    /**
     * 商铺地址
     */
    private String shopAddress;

    /**
     * 均价
     */
    private String averagePrice;

    /**
     * 商铺经度
     */
    private String shopLongitude;

    /**
     * 商铺纬度
     */
    private String shopLatitude;

    /**
     * 商铺介绍
     */
    private String shopIntroduction;

    /**
     * 创建时间
     */
    private LocalDateTime createDate;

    /**
     * 创建人
     */
    private Integer createUser;

    /**
     * 更新时间
     */
    private LocalDateTime updateDate;

    /**
     * 更新人
     */
    private Integer updateUser;
    
    /**
     * 类型名称
     */
    @TableField(exist = false)
    private String typeName;
    
    /**
     * 首页图片地址
     */
    @TableField(exist = false)
    private String imgUrl;
    
    /**
     * 更新人姓名
     */
    @TableField(exist = false)
    private String userName;
    
    /**
     * 首页图片地址
     */
    @TableField(exist = false)
    private String appIndexImg;
    
    /**
     * app列表展示图
     */
    @TableField(exist = false)
    private String appListImg;
    
    /**
     * app商铺轮播图
     */
    @TableField(exist = false)
    private List<String> appCarouselImg;

    /**
     * 评价总数
     */
    @TableField(exist = false)
    private int evaluateSum;
}
